
;SIZE_X equ 350
;SIZE_Y equ 350
;ROUND equ 8
;TEX_X equ 512
;TEX_Y equ 512
;TEXTURE_SIZE EQU (512*512)-1
;TEX_SHIFT EQU 9

;CATMULL_SHIFT equ 8
;TEXTURE_SIZE EQU (TEX_X * TEX_Y)-1
;Ext = SSE
;SSE = 3
;MMX = 1
;NON = 0
;use32
;------- Big thanks to Majuma (www.majuma.xt.pl) for absolutely great---
;------- DOS 13h mode demos --------------------------------------------
;------- Procedure draws triangle with two overlapped textures, I use --
;--------Catmull Z-buffer algorithm- (Z coordinate interpolation)-------
;--------I calc texture pixel by this way: col1*col2/256 ---------------
two_tex_triangle_z:
;------------------in - eax - x1 shl 16 + y1 -----------
;---------------------- ebx - x2 shl 16 + y2 -----------
;---------------------- ecx - x3 shl 16 + y3 -----------
;---------------------- edx - pointer to b. texture-----
;---------------------- esi - pointer to e. texture-----
;---------------------- edi - pointer to screen buffer--
;---------------------- stack : b. tex coordinates------
;----------------------         e. tex coordinates------
;----------------------         Z position coordinates--
;----------------------         pointer io Z buffer-----
;-- Z-buffer - filled with coordinates as dword --------
;-- (Z coor. as word) shl CATMULL_SHIFT ----------------
.b_x1	equ ebp+4   ; procedure don't save registers !!!
.b_y1	equ ebp+6   ; each coordinate as word
.b_x2	equ ebp+8
.b_y2	equ ebp+10	 ; b - first texture
.b_x3	equ ebp+12
.b_y3	equ ebp+14	 ; e - second texture
.e_x1	equ ebp+16
.e_y1	equ ebp+18
.e_x2	equ ebp+20
.e_y2	equ ebp+22
.e_x3	equ ebp+24
.e_y3	equ ebp+26
.z1	equ word[ebp+28]
.z2	equ word[ebp+30]
.z3	equ word[ebp+32]
.z_buff equ dword[ebp+34]	; pointer to Z-buffer


.t_bmap equ dword[ebp-4]	; pointer to b. texture
.t_emap equ dword[ebp-8]	; pointer to e. texture
.x1	equ word[ebp-10]
.y1	equ word[ebp-12]
.x2	equ word[ebp-14]
.y2	equ word[ebp-16]
.x3	equ word[ebp-18]
.y3	equ word[ebp-20]

.dx12  equ dword[ebp-24]
.dbx12 equ dword[ebp-28]
.dby12 equ dword[ebp-32]
.dby12q equ	[ebp-32]
.dex12 equ dword[ebp-36]
.dey12 equ dword[ebp-40]
.dey12q equ	[ebp-40]
.dz12  equ dword[ebp-44]

.dx13  equ dword[ebp-48]
.dbx13 equ dword[ebp-52]
.dby13 equ dword[ebp-56]
.dby13q equ	[ebp-56]
.dex13 equ dword[ebp-60]
.dey13 equ dword[ebp-64]
.dey13q equ	[ebp-64]
.dz13  equ dword[ebp-68]

.dx23  equ dword[ebp-72]
.dbx23 equ dword[ebp-76]
.dby23 equ dword[ebp-80]
.dby23q equ	[ebp-80]
.dex23 equ dword[ebp-84]
.dey23 equ dword[ebp-88]
.dey23q equ	[ebp-88]
.dz23  equ dword[ebp-92]

.cx1   equ dword[ebp-96]   ; current variables
.cx2   equ dword[ebp-100]
.cbx1  equ dword[ebp-104]
.cby1  equ [ebp-108]
.cex1  equ dword[ebp-112]
.cey1  equ [ebp-116]
.cbx2  equ dword[ebp-120]
.cby2  equ [ebp-124]
.cex2  equ dword[ebp-128]
.cey2  equ [ebp-132]

.cz1   equ dword[ebp-136]
.cz2   equ dword[ebp-140]

    if Ext >= MMX
       emms
    else
       cld
    end if
       mov     ebp,esp
       push    edx esi	     ; store bump map
;       push    esi        ; store e. map
     ; sub     esp,120
 .sort3:		  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       mov     edx,dword[.b_x1]
       xchg    edx,dword[.b_x2]
       mov     dword[.b_x1],edx
       mov     edx,dword[.e_x1]
       xchg    edx,dword[.e_x2]
       mov     dword[.e_x1],edx
       mov     dx,.z1
       xchg    dx,.z2
       mov     .z1,dx
 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg	ebx,ecx
       mov	edx,dword[.b_x2]
       xchg	edx,dword[.b_x3]
       mov	dword[.b_x2],edx
       mov	edx,dword[.e_x2]
       xchg	edx,dword[.e_x3]
       mov	dword[.e_x2],edx
       mov     dx,.z2
       xchg    dx,.z3
       mov     .z2,dx
       jmp	.sort3
 .sort2:
       push	eax ebx ecx    ; store triangle coords in variables
;       push     ebx
;       push     ecx

	 mov	  edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
	 and	  edx,ebx	 ; if *all* of them are negative a sign flag is raised
	 and	  edx,ecx
	 and	  edx,eax
	 test	  edx,80008000h  ; Check both X&Y at once
	 jne	  .loop23_done
    ;   mov     edx,eax         ; eax,ebx,ecx are ORd together into edx which means that
    ;   or      edx,ebx         ; if any *one* of them is negative a sign flag is raised
    ;   or      edx,ecx
    ;   test    edx,80000000h   ; Check only X
    ;   jne     .loop23_done

    ;   cmp     .x1,SIZE_X    ; {
    ;   jg      .loop23_done
    ;   cmp     .x2,SIZE_X     ; This can be optimized with effort
    ;   jg      .loop23_done
    ;   cmp     .x3,SIZE_X
    ;   jg      .loop23_done    ; {


       mov	bx,.y2	     ; calc delta 12
       sub	bx,.y1
       jnz	.bt_dx12_make
       mov	ecx,6
       xor	edx,edx
     @@:
       push	edx   ;dword 0
       loop	@b
       jmp	.bt_dx12_done
 .bt_dx12_make:
if 1
       mov	ax,.x2
       sub	ax,.x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
;      mov      .dx12,eax
       push	 eax

else

	mov    cx,.x2
	sub    cx,.x1
	movsx  ecx,cx
	movsx  ebx,bx

	mov	eax,65536
	cdq
	idiv	ebx

	mov	ebx,eax
	imul	ecx
	sar	eax,8
	push	eax

       mov	cx,word[.b_x2]
       sub	cx,word[.b_x1]
       movsx	ecx,cx
       mov	eax,ebx
       imul	ecx
       sar	eax,8
       push	eax


      mov      cx,word[.b_y2]
      sub      cx,word[.b_y1]
      movsx    ecx,cx
      mov      eax,ebx
      imul     ecx
      sar      eax,8
      push     eax

      mov      cx,word[.e_x2]
      sub      cx,word[.e_x1]
      movsx    ecx,cx
      mov      eax,ebx
      imul     ecx
      sar      eax,8
      push     eax

      mov      cx,word[.e_y2]
      sub      cx,word[.e_y1]
      movsx    ecx,cx
      mov      eax,ebx
      imul     ecx
      sar      eax,8
      push     eax

      mov      cx,.z2
      sub      cx,.z1
      movsx    ecx,cx
      mov      eax,ebx
      imul     ecx
      sar      eax,8
      push     eax
end if
if 0
      sub	esp,16
      movd	xmm7,[.b_x1]
      pxor	xmm4,xmm4
      movd	xmm6,[.e_x1]
      punpcklwd xmm7,xmm4
      punpcklwd xmm6,xmm4
      punpcklqdq xmm7,xmm6
      movd	xmm6,[.b_x2]
      movd	xmm5,[.e_x2]
      punpcklwd xmm6,xmm4
      punpcklwd xmm5,xmm4
      punpcklqdq xmm6,xmm5
      psubd	xmm6,xmm7
      movd	xmm3,ebx
      pshufd	xmm3,xmm3,0
      pmulld	xmm6,xmm3 ; PMULLW
      psrad	xmm6,16
      pshufd	 xmm6,xmm6,00011011b
      movups	.dey12q,xmm6

      mov      cx,.z2
      sub      cx,.z1
      movsx    ecx,cx
      mov      eax,ebx
      imul     ecx
      sar      eax,16
      push     eax


end if
if Ext >= SSE2
       sub	 esp,16
       cvtsi2ss  xmm3,ebx
       cvtsi2ss  xmm4,[i255d]
       rcpss	 xmm3,xmm3
       mulss	 xmm3,xmm4
       shufps	 xmm3,xmm3,0
       movd	 xmm7,[.b_x1]
       pxor	 xmm4,xmm4
       movd	 xmm6,[.e_x1]
       punpcklwd xmm7,xmm4
       punpcklwd xmm6,xmm4
       punpcklqdq xmm7,xmm6
    ;   movlhps   xmm7,xmm6
       movd	 xmm6,[.b_x2]
       movd	 xmm5,[.e_x2]
       punpcklwd xmm6,xmm4
       punpcklwd xmm5,xmm4
       punpcklqdq xmm6,xmm5
     ;  movlhps   xmm6,xmm5
       psubd	 xmm6,xmm7
       cvtdq2ps  xmm6,xmm6
       mulps	 xmm6,xmm3
       shufps	 xmm6,xmm6,00011011b
       cvtps2dq  xmm6,xmm6
       movups	 .dey12q,xmm6


else if Ext = SSE

       sub	 esp,16
       cvtsi2ss  xmm3,ebx	     ;rcps
    ;   mov       eax,255
       cvtsi2ss  xmm4,[i255d] ;eax
       divss	 xmm3,xmm4
       rcpss	 xmm3,xmm3
    ;   mulss     xmm3,xmm4
       shufps	 xmm3,xmm3,0

       movd	 mm0,[.b_x1]
       movd	 mm1,[.b_x2]
       movd	 mm2,[.e_x1]
       movd	 mm3,[.e_x2]
     ;  psubsw    mm3,mm2
     ;  psubsw    mm1,mm0
       pxor	 mm4,mm4
       punpcklwd mm0,mm4
       punpcklwd mm1,mm4
       punpcklwd mm2,mm4
       punpcklwd mm3,mm4

       cvtpi2ps  xmm0,mm0
       movlhps	 xmm0,xmm0
       cvtpi2ps  xmm0,mm2
       cvtpi2ps  xmm1,mm1
       movlhps	 xmm1,xmm1
       cvtpi2ps  xmm1,mm3
       subps	 xmm1,xmm0

       mulps	 xmm1,xmm3
       shufps	 xmm1,xmm1,10110001b
       cvtps2pi  mm0,xmm1	   ; mm0 -> 2 delta dwords
       movhlps	 xmm1,xmm1
       cvtps2pi  mm1,xmm1
       movq	 .dey12q,mm0
       movq	 .dby12q,mm1

else if Ext<SSE
       mov	ax,word[.b_x2]
       sub	ax,word[.b_x1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;     mov      .dbx12,eax
       push	 eax

       mov	ax,word[.b_y2]
       sub	ax,word[.b_y1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;     mov      .dby12,eax
       push	 eax

 ;     mov       eax,.dbx12
 ;     mov       ebx,.dby12
 ;     int3

       mov	ax,word[.e_x2]
       sub	ax,word[.e_x1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dex12,eax
       push	 eax

       mov	ax,word[.e_y2]
       sub	ax,word[.e_y1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dey12,eax
       push	 eax

end if
	mov	ax,.z2
	sub	ax,.z1
	cwde
	shl	eax,CATMULL_SHIFT
	cdq
	idiv	ebx
	push	eax
;end if
   .bt_dx12_done:

       mov	bx,.y3	     ; calc delta13
       sub	bx,.y1
       jnz	.bt_dx13_make
       mov	ecx,6
       xor	edx,edx
     @@:
       push	edx   ;dword 0
       loop	@b
       jmp	.bt_dx13_done
 .bt_dx13_make:
       mov	ax,.x3
       sub	ax,.x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dx13,eax
       push	 eax

if Ext >= SSE2
       sub	 esp,16
       cvtsi2ss  xmm3,ebx
       cvtsi2ss  xmm4,[i255d]
       rcpss	 xmm3,xmm3
       mulss	 xmm3,xmm4
       shufps	 xmm3,xmm3,0
       movd	 xmm7,[.b_x1]
       pxor	 xmm4,xmm4
       movd	 xmm6,[.e_x1]
       punpcklwd xmm7,xmm4
       punpcklwd xmm6,xmm4
       punpcklqdq xmm7,xmm6
    ;   movlhps   xmm7,xmm6
       movd	 xmm6,[.b_x3]
       movd	 xmm5,[.e_x3]
       punpcklwd xmm6,xmm4
       punpcklwd xmm5,xmm4
       punpcklqdq xmm6,xmm5
     ;  movlhps   xmm6,xmm5
       psubd	 xmm6,xmm7
       cvtdq2ps  xmm6,xmm6
       mulps	 xmm6,xmm3
       shufps	 xmm6,xmm6,00011011b
       cvtps2dq  xmm6,xmm6
       movups	 .dey13q,xmm6


else if Ext=SSE

       cvtsi2ss  xmm3,ebx
  ;     mov       eax,255
       cvtsi2ss  xmm4,[i255d]
       divss	 xmm3,xmm4
       rcpss	 xmm3,xmm3
;       mulss     xmm3,xmm4
       shufps	 xmm3,xmm3,0
       sub	 esp,16

       movd	 mm0,[.b_x1]
       movd	 mm1,[.b_x3]
       movd	 mm2,[.e_x1]
       movd	 mm3,[.e_x3]

       pxor	 mm4,mm4
       punpcklwd mm0,mm4
       punpcklwd mm1,mm4
       punpcklwd mm2,mm4
       punpcklwd mm3,mm4

       cvtpi2ps  xmm0,mm0
       movlhps	 xmm0,xmm0
       cvtpi2ps  xmm0,mm2
       cvtpi2ps  xmm1,mm1
       movlhps	 xmm1,xmm1
       cvtpi2ps  xmm1,mm3
       subps	 xmm1,xmm0

   ;    divps     xmm1,xmm3
       mulps	 xmm1,xmm3
       shufps	 xmm1,xmm1,10110001b
       cvtps2pi  mm0,xmm1	   ; mm0 -> 2 delta dwords
       movhlps	 xmm1,xmm1
       cvtps2pi  mm1,xmm1
       movq	 .dey13q,mm0
       movq	 .dby13q,mm1

else

       mov	ax,word[.b_x3]
       sub	ax,word[.b_x1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dbx13,eax
       push	 eax

       mov	ax,word[.b_y3]
       sub	ax,word[.b_y1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dby13,eax
       push	 eax

       mov	ax,word[.e_x3]
       sub	ax,word[.e_x1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dex13,eax
       push	 eax

       mov	ax,word[.e_y3]
       sub	ax,word[.e_y1]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dey13,eax
       push	 eax

end if

       mov     ax,.z3
       sub     ax,.z1
       cwde
       shl     eax,CATMULL_SHIFT
       cdq
       idiv    ebx
  ;    mov    .dz13,eax
       push    eax
   .bt_dx13_done:

       mov	bx,.y3	     ; calc delta23
       sub	bx,.y2
       jnz	.bt_dx23_make
       mov	ecx,6
       xor	edx,edx
     @@:
       push	edx   ;dword 0
       loop	@b
       jmp	.bt_dx23_done
 .bt_dx23_make:
       mov	ax,.x3
       sub	ax,.x2
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dx23,eax
       push	 eax

if Ext >= SSE2
       sub	 esp,16
       cvtsi2ss  xmm3,ebx
       cvtsi2ss  xmm4,[i255d]
       rcpss	 xmm3,xmm3
       mulss	 xmm3,xmm4
       shufps	 xmm3,xmm3,0
       movd	 xmm7,[.b_x2]
       pxor	 xmm4,xmm4
       movd	 xmm6,[.e_x2]
       punpcklwd xmm7,xmm4
       punpcklwd xmm6,xmm4
       punpcklqdq xmm7,xmm6
    ;   movlhps   xmm7,xmm6
       movd	 xmm6,[.b_x3]
       movd	 xmm5,[.e_x3]
       punpcklwd xmm6,xmm4
       punpcklwd xmm5,xmm4
       punpcklqdq xmm6,xmm5
     ;  movlhps   xmm6,xmm5
       psubd	 xmm6,xmm7
       cvtdq2ps  xmm6,xmm6
       mulps	 xmm6,xmm3
       shufps	 xmm6,xmm6,00011011b
       cvtps2dq  xmm6,xmm6
       movups	 .dey23q,xmm6

else if Ext=SSE

       cvtsi2ss  xmm3,ebx
     ;  mov       eax,255
       cvtsi2ss  xmm4,[i255d] ;eax
       divss	 xmm3,xmm4
       shufps	 xmm3,xmm3,0
       sub	 esp,16

       movd	 mm0,[.b_x2]
       movd	 mm1,[.b_x3]
       movd	 mm2,[.e_x2]
       movd	 mm3,[.e_x3]

       pxor	 mm4,mm4
       punpcklwd mm0,mm4
       punpcklwd mm1,mm4
       punpcklwd mm2,mm4
       punpcklwd mm3,mm4

       cvtpi2ps  xmm0,mm0
       movlhps	 xmm0,xmm0
       cvtpi2ps  xmm0,mm2
       cvtpi2ps  xmm1,mm1
       movlhps	 xmm1,xmm1
       cvtpi2ps  xmm1,mm3
       subps	 xmm1,xmm0

       divps	 xmm1,xmm3
       shufps	 xmm1,xmm1,10110001b
       cvtps2pi  mm0,xmm1	   ; mm0 -> 2 delta dwords
       movhlps	 xmm1,xmm1
       cvtps2pi  mm1,xmm1
       movq	 .dey23q,mm0
       movq	 .dby23q,mm1

else

       mov	ax,word[.b_x3]
       sub	ax,word[.b_x2]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dbx23,eax
       push	 eax

       mov	ax,word[.b_y3]
       sub	ax,word[.b_y2]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dby23,eax
       push	 eax

       mov	ax,word[.e_x3]
       sub	ax,word[.e_x2]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dex23,eax
       push	 eax

       mov	ax,word[.e_y3]
       sub	ax,word[.e_y2]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dey23,eax
       push	 eax
end if
       mov     ax,.z3
       sub     ax,.z2
       cwde
       shl     eax,CATMULL_SHIFT
       cdq
       idiv    ebx
      ; mov     .dz23,eax
       push    eax
      ;  sub     esp,40
   .bt_dx23_done:
       movsx	eax,.x1
       shl	eax,ROUND
     ;  mov      .cx1,eax
     ;  mov      .cx2,eax
       push	eax eax
     ; push     eax

       movsx	eax,word[.b_x1]
       shl	eax,ROUND
       mov	.cbx1,eax
       mov	.cbx2,eax
     ;  push     eax eax
     ; push     eax

       movsx	eax,word[.b_y1]
       shl	eax,ROUND
       mov	.cby1,eax
       mov	.cby2,eax
     ;  push     eax eax
     ; push     eax

       movsx	eax,word[.e_x1]
       shl	eax,ROUND
       mov	.cex1,eax
       mov	.cex2,eax
      ; push     eax eax
      ;push     eax

       movsx	eax,word[.e_y1]
       shl	eax,ROUND
       mov	.cey1,eax
       mov	.cey2,eax
       sub	esp,32
      ; push     eax eax
      ;push     eax

       movsx	eax,.z1
       shl	eax,CATMULL_SHIFT
      ; mov      .cz1,eax
      ; mov      .cz2,eax
      push     eax eax
      ;push     eax

       movsx	ecx,.y1
       cmp	cx,.y2
       jge	.loop12_done
  .loop12:
       call	.call_line

       mov	eax,.dx13
       add	.cx1,eax
       mov	ebx,.dx12
       add	.cx2,ebx
if Ext>= SSE2
       movups	xmm0,.cey1
       movups	xmm1,.cey2
       movups	xmm2,.dey12q
       movups	xmm3,.dey13q
       paddd	xmm0,xmm3
       paddd	xmm1,xmm2
       movups	.cey1,xmm0
       movups	.cey2,xmm1
else if (Ext = MMX) | (Ext=SSE)
       movq	mm0,.cby2	; with this optimization object
       movq	mm1,.cby1	; looks bit annoying
       movq	mm2,.cey2
       movq	mm3,.cey1
       paddd	mm0,.dby12q
       paddd	mm1,.dby13q
       paddd	mm2,.dey12q
       paddd	mm3,.dey13q
       movq	.cby2,mm0
       movq	.cby1,mm1
       movq	.cey1,mm3
       movq	.cey2,mm2
else
       mov	edx,.dbx13
       add	.cbx1,edx
       mov	eax,.dbx12
       add	.cbx2,eax
       mov	ebx,.dby13
       add	.cby1,ebx
       mov	edx,.dby12
       add	.cby2,edx

       mov	eax,.dex13
       add	.cex1,eax
       mov	ebx,.dex12
       add	.cex2,ebx
       mov	edx,.dey13
       add	.cey1,edx
       mov	eax,.dey12
       add	.cey2,eax

end if
       mov	ebx,.dz13
       add	.cz1,ebx
       mov	edx,.dz12
       add	.cz2,edx

       inc	ecx
       cmp	cx,.y2
       jl	.loop12
    .loop12_done:

       movsx	ecx,.y2
       cmp	cx,.y3
       jge	.loop23_done

       movsx	eax,.z2
       shl	eax,CATMULL_SHIFT
       mov	.cz2,eax

       movsx	eax,.x2
       shl	eax,ROUND
       mov	.cx2,eax

       movzx	eax,word[.b_x2]
       shl	eax,ROUND
       mov	.cbx2,eax

       movzx	eax,word[.b_y2]
       shl	eax,ROUND
       mov	.cby2,eax

       movzx	eax,word[.e_x2]
       shl	eax,ROUND
       mov	.cex2,eax

       movzx	eax,word[.e_y2]
       shl	eax,ROUND
       mov	.cey2,eax

     .loop23:
       call	.call_line
;if Ext = NON
       mov	eax,.dx13
       add	.cx1,eax
       mov	ebx,.dx23
       add	.cx2,ebx
if Ext>= SSE2
       movups	xmm0,.cey1
       movups	xmm1,.cey2
       movups	xmm2,.dey23q
       movups	xmm3,.dey13q
       paddd	xmm0,xmm3
       paddd	xmm1,xmm2
       movups	.cey1,xmm0
       movups	.cey2,xmm1
else if (Ext = MMX) | ( Ext = SSE)
       movq	mm0,.cby2	 ;    with this mmx optimization object looks bit
       movq	mm1,.cby1	 ;    annoying
       movq	mm2,.cey2
       movq	mm3,.cey1
       paddd	mm0,.dby23q
       paddd	mm1,.dby13q
       paddd	mm2,.dey23q
       paddd	mm3,.dey13q
       movq	.cby2,mm0
       movq	.cby1,mm1
       movq	.cey2,mm2
       movq	.cey1,mm3

else
       mov	edx,.dbx13
       add	.cbx1,edx
       mov	eax,.dbx23
       add	.cbx2,eax
       mov	ebx,.dby13
       add	.cby1,ebx
       mov	edx,.dby23
       add	.cby2,edx

       mov	eax,.dex13
       add	.cex1,eax
       mov	ebx,.dex23
       add	.cex2,ebx
       mov	edx,.dey13
       add	.cey1,edx
       mov	eax,.dey23
       add	.cey2,eax
end if

       mov	ebx,.dz13
       add	.cz1,ebx
       mov	edx,.dz23
       add	.cz2,edx
;else
;       movq     mm0,.db13q
;       movq     mm1,.cbx1q

       inc	ecx
       cmp	cx,.y3
       jl	.loop23
    .loop23_done:

       mov	esp,ebp
ret   34

.call_line:

       pushad

       push	.cz1
       push	.cz2
       push	.z_buff
       push	.t_bmap
       push	.t_emap
       push	dword .cey2
       push	.cex2
       push	dword .cey1
       push	.cex1
       push	dword .cby2
       push	.cbx2
       push	dword .cby1
       push	.cbx1
       push	ecx

       mov	eax,.cx1
       sar	eax,ROUND
       mov	ebx,.cx2
       sar	ebx,ROUND

       call	two_tex_line_z

       popad
ret
two_tex_line_z:
;--------------in: eax - x1
;--------------    ebx - x2
;--------------    edi - pointer to screen buffer
;stack - another parameters :
.y	equ dword [ebp+4]
.bx1	equ  [ebp+8]   ;   ---
.by1	equ  [ebp+12]  ;       |
.bx2	equ  [ebp+16]  ;       |
.by2	equ  [ebp+20]  ;       |>   b. texture and e. texture coords
.ex1	equ  [ebp+24]  ;       |>   shifted shl ROUND
.ey1	equ  [ebp+28]  ;       |
.ex2	equ  [ebp+32]  ;       |
.ey2	equ  [ebp+36]  ;   ---
.emap	equ  [ebp+40]  ; b texture offset
.bmap	equ  [ebp+44]  ; e texture offset
.z_buff equ dword [ebp+48]
.z2	equ dword [ebp+52]  ;   -- |>   z coords shifted
.z1	equ dword [ebp+56]  ;   --       shl  CATMULL_SHIFT

.x1	equ dword [ebp-4]
.x2	equ dword [ebp-8]
.dbx	equ [ebp-12]
.dex	equ [ebp-16]
.dby	equ [ebp-20]
.dey	equ [ebp-24]
.dz	equ dword [ebp-28]
.cbx	equ [ebp-32]
.cex	equ [ebp-36]
.cby	equ [ebp-40]
.cey	equ [ebp-44]
.cz	equ dword [ebp-48]
.czbuff equ dword [ebp-52]
.screen equ dword [ebp-56]
.rest	equ ebp-60



.dbyI	 equ dword ebx
.dbyII	 equ dword ebx+4
.dbyIII  equ dword ebx+8
.dbyIV	 equ dword ebx+12
.dbxI	 equ dword ebx+16
.dbxII	 equ dword ebx+20
.dbxIII  equ dword ebx+24
.dbxIV	 equ dword ebx+28

.deyI	 equ dword ebx+32
.deyII	 equ dword ebx+36
.deyIII  equ dword ebx+40
.deyIV	 equ dword ebx+44
.dexI	 equ dword ebx+48
.dexII	 equ dword ebx+52
.dexIII  equ dword ebx+56
.dexIV	 equ dword ebx+60

.dzI	    equ dword ebx+64
.dzII	    equ dword ebx+68
.dzIII	    equ dword ebx+72
.dzIV	    equ dword ebx+76

.cbyI	     equ dword ebx+80
.cbyII	     equ dword ebx+84
.cbyIII      equ dword ebx+88
.cbyIV	     equ dword ebx+92
.cbxI	     equ dword ebx+96
.cbxII	     equ dword ebx+100
.cbxIII      equ dword ebx+104
.cbxIV	     equ dword ebx+108

.ceyI	     equ dword ebx+112
.ceyII	     equ dword ebx+116
.ceyIII      equ dword ebx+120
.ceyIV	     equ dword ebx+124
.cexI	     equ dword ebx+128
.cexII	     equ dword ebx+132
.cexIII      equ dword ebx+136
.cexIV	     equ dword ebx+140

.czI	    equ dword ebx+144
.czII	    equ dword ebx+148
.czIII	    equ dword ebx+152
.czIV	    equ dword ebx+156

.emapI	 equ dword ebx+160
.emapII  equ dword ebx+164
.emapIII equ dword ebx+168
.emapIV  equ dword ebx+172

.bmapI	 equ dword ebx+176
.bmapII  equ dword ebx+180
.bmapIII equ dword ebx+184
.bmapIV  equ dword ebx+188

.colI	    equ dword ebx+192
.colII	    equ dword ebx+196
.colIII     equ dword ebx+200
.colIV	    equ dword ebx+204

.col2I	    equ dword ebx+208
.col2II     equ dword ebx+212
.col2III    equ dword ebx+216
.col2IV     equ dword ebx+220
	mov	ebp,esp

	mov	ecx,.y
	or	ecx,ecx
	jl	.bl_end
	cmp	ecx,SIZE_Y
	jge	.bl_end

	cmp	eax,ebx
	jl	@f
	je	.bl_end

	xchg	eax,ebx
if Ext=NON
	mov	edx,.bx1
	xchg	edx,.bx2
	mov	.bx1,edx
	mov	edx,.by1
	xchg	edx,.by2
	mov	.by1,edx

	mov	edx,.ex1
	xchg	edx,.ex2
	mov	.ex1,edx
	mov	edx,.ey1
	xchg	edx,.ey2
	mov	.ey1,edx
else
	movq	mm0,.bx1
	movq	mm1,.ex1
	movq	mm2,.bx2
	movq	mm3,.ex2
	movq	.bx2,mm0
	movq	.ex2,mm1
	movq	.bx1,mm2
	movq	.ex1,mm3
end if
	mov	edx,.z1
	xchg	edx,.z2
	mov	.z1,edx
    @@:
	push	eax ebx
;        push    ebx           ;store x1, x2

	cmp	.x1,SIZE_X
	jge	.bl_end
	cmp	.x2,0
	jle	.bl_end

	mov	ebx,.x2
	sub	ebx,.x1

;if  Ext >= SSE2
;
;       sub       esp,16
;       cvtsi2ss  xmm3,ebx            ;rcps
;       shufps    xmm3,xmm3,0
;
;       movups    xmm0,.bx1        ; xmm0 = bx1,by1,bx2,by2
;       movups    xmm1,.ex1        ; xmm1 = ex1,ey1,ex2,ey2
;       movaps    xmm7,xmm0
;       movaps    xmm6,xmm1
;       punpcklqdq xmm0,xmm1       ; xmm0 = bx1,by1,ex1,ey1
;       punpcklqdq xmm7,xmm6       ; xmm7 = bx2,by2,ex2,ey2
;       psubd     xmm7,xmm0
;       cvtdq2ps  xmm7,xmm7
;
;       divps     xmm7,xmm3
;
;       shufps    xmm7,xmm7,10000111b ;01110010b  ;11011000b ;00011110b ;10110001b
;       cvtps2dq  xmm7,xmm7
;
;       movups    .dey,xmm7
;else
if Ext>=SSE

       sub	 esp,16
       cvtsi2ss  xmm3,ebx	     ;rcps
       shufps	 xmm3,xmm3,0

       cvtpi2ps  xmm0,.bx1 ;mm0     ; bx1; by1
       movlhps	 xmm0,xmm0
       cvtpi2ps  xmm0,.ex1 ;mm2     ; ex1; ey1
       cvtpi2ps  xmm1,.bx2 ;mm1     ; bx2; by2
       movlhps	 xmm1,xmm1
       cvtpi2ps  xmm1,.ex2 ;mm3     ; ex2; ey2
       subps	 xmm1,xmm0
				    ; hi             lo
       divps	 xmm1,xmm3 ; xmm1 -> dby; dbx; dey; dex

       shufps	 xmm1,xmm1,11011000b
       cvtps2pi  mm0,xmm1	   ; mm0 -> 2 delta dwords
       movhlps	 xmm1,xmm1
       cvtps2pi  mm1,xmm1
       movq	 .dex,mm0 ; hi - lo  ->  dbx, dex
       movq	 .dey,mm1 ; hi - lo  ->  dby, dey

else

	mov	eax,.bx2       ; calc .dbx
	sub	eax,.bx1
	cdq
	idiv	ebx
	push	eax

	mov	eax,.ex2       ; calc .dby
	sub	eax,.ex1
	cdq
	idiv	ebx
	push	eax

	mov	eax,.by2       ; calc .dex
	sub	eax,.by1
	cdq
	idiv	ebx
	push	eax

	mov	eax,.ey2       ; calc .dey
	sub	eax,.ey1
	cdq
	idiv	ebx
	push	eax

end if

	mov	eax,.z2        ; calc .dz
	sub	eax,.z1
	cdq
	idiv	ebx
	push	eax

	cmp	.x1,0	      ; set correctly begin variable
	jge	@f	      ; CLIPPING ON FUNCTION
			      ; cutting triangle exceedes screen
	mov	ebx,.x1
	neg	ebx
	imul	ebx	      ; eax = .dz * abs(.x1)
	add	.z1,eax
	mov	.x1,0

	mov	eax,.dbx
	imul	ebx
	add    .bx1,eax

	mov	eax,.dby
	imul	ebx
	add	.by1,eax

	mov	eax,.dex
	imul	ebx
	add	.ex1,eax

	mov	eax,.dey
	imul	ebx
	add	.ey1,eax
      @@:
	cmp	.x2,SIZE_X
	jl	@f
	mov	.x2,SIZE_X
      @@:
	mov	eax,SIZE_X	 ;calc memory begin in buffers
	mov	ebx,.y
	mul	ebx
	mov	ebx,.x1
	add	eax,ebx
	shl	eax,2
	add	edi,eax 	  ; edi - screen
	mov	esi,.z_buff	  ; z-buffer filled with dd variables
	add	esi,eax 	  ; esi - Z buffer

	mov	ecx,.x2
	sub	ecx,.x1
	or	ecx,ecx
	jz	.bl_end
	; init current variables
	push	dword .bx1 ;.by1 .ex1 .ey1 .z1 esi
	push	dword .ex1
	push	dword .by1
	push	dword .ey1

	push	.z1		 ; current z shl CATMULL_SHIFT
	push	esi
	push	edi		 ; screen buffer ptr
	sub	esp,4

	mov	  word [.rest],0
	shr	  ecx,1
	jnc	  @f
	add	  word [.rest],1
    @@:
	shr	  ecx,1
	jnc	  @f
	add	  word	[.rest],2
    @@:
	cmp	  ecx,0
	jz	  .draw_last1


	 mov	  ebx,sse_repository
	 movd	  xmm1,.bx1
	 shufps   xmm1,xmm1,0				
	 movd	  xmm0,.dbx
	 shufps   xmm0,xmm0,0				
	 movaps   xmm7,xmm0		   ; xmm7 -> dbx
	 cvtdq2ps xmm0,xmm0				
	 mulps	  xmm0,[muler0123]			
	 cvtps2dq xmm0,xmm0				
	 paddd	  xmm1,xmm0				
	 movaps   [.cbxI],xmm1
	 pslld	  xmm7,2				
	 movaps   [.dbxI],xmm7

	 movd	  xmm1,.by1
	 shufps   xmm1,xmm1,0				
	 movd	  xmm0,.dby
	 shufps   xmm0,xmm0,0				
	 movaps   xmm7,xmm0		   ; xmm7 -> dby
	 cvtdq2ps xmm0,xmm0				
	 mulps	  xmm0,[muler0123]			
	 cvtps2dq xmm0,xmm0				
	 paddd	  xmm1,xmm0				
	 movaps   [.cbyI],xmm1
	 pslld	  xmm7,2				
	 movaps   [.dbyI],xmm7

	 movd	  xmm1,.ex1
	 shufps   xmm1,xmm1,0				
	 movd	  xmm0,.dex
	 shufps   xmm0,xmm0,0				
	 movaps   xmm7,xmm0		   ; xmm7 -> dex
	 cvtdq2ps xmm0,xmm0
	 mulps	  xmm0,[muler0123]			
	 cvtps2dq xmm0,xmm0				
	 paddd	  xmm1,xmm0				
	 movaps   [.cexI],xmm1
	 pslld	  xmm7,2				
	 movaps   [.dexI],xmm7

	 movd	  xmm1,.ey1
	 shufps   xmm1,xmm1,0				
	 movd	  xmm0,.dey
	 shufps   xmm0,xmm0,0				
	 movaps   xmm7,xmm0		   ; xmm7 -> dby
	 cvtdq2ps xmm0,xmm0				
	 mulps	  xmm0,[muler0123]			
	 cvtps2dq xmm0,xmm0				
	 paddd	  xmm1,xmm0
	 movaps   [.ceyI],xmm1
	 pslld	  xmm7,2				
	 movaps   [.deyI],xmm7

	 movd	  xmm1,.z1
	 shufps   xmm1,xmm1,0
	 movd	  xmm0,.dz
	 shufps   xmm0,xmm0,0
	 movaps   xmm7,xmm0		   ; xmm7 -> dz
	 cvtdq2ps xmm0,xmm0
	 mulps	  xmm0,[muler0123]
	 cvtps2dq xmm0,xmm0
	 paddd	  xmm1,xmm0
	 movaps   [.czI],xmm1	       ; xmm1 -> cz
	 pslld	  xmm7,2
	 movaps   [.dzI],xmm7

	 movd	  xmm7,.emap
	 shufps   xmm7,xmm7,0
	 movaps   [.emapI],xmm7

	 movd	  xmm6,.bmap
	 shufps   xmm6,xmm6,0
	 movaps   [.bmapI],xmm6

   ;      shr      ecx,2
   ;      or       ecx,ecx
   ;      jz       .bl_end
	 movaps   xmm1,[.czI]
	 movaps   xmm2,[.ceyI]
     .draw:

	mov	   edi,.czbuff
	movups	   xmm0,[edi]
    ;    movaps     xmm1,[.czI]
	pcmpgtd    xmm0,xmm1	     ; packed compare Z buffer
	pmovmskb   eax,xmm0	     ; check cause if all bits are zeroed
	or	   eax,eax	     ; xmm0 -> mask
	jz	   .nd

	movaps	   xmm7,[.cbyI]
	movaps	   xmm6,[.cbxI]
	psrad	   xmm7,ROUND
	psrad	   xmm6,ROUND
	pslld	   xmm7,TEX_SHIFT
	paddd	   xmm7,xmm6
	pand	   xmm7,[tex_cutter]
	pslld	   xmm7,2
	paddd	   xmm7,[.bmapI]    ; xmm7 ->  4 adresses for b pixels

	movaps	   xmm6,xmm2 ;[.ceyI]
	movaps	   xmm5,[.cexI]
	psrad	   xmm6,ROUND
	psrad	   xmm5,ROUND
	pslld	   xmm6,TEX_SHIFT
	paddd	   xmm6,xmm5
	pand	   xmm6,[tex_cutter]
	pslld	   xmm6,2
	paddd	   xmm6,[.emapI]    ; xmm6 ->  4 adresses for e pixels
if Ext >= SSE4.1
       movups	  xmm5,[edi]
       pblendvb   xmm5,xmm1	    ; actualize z buffer
       movups	  [edi],xmm5

       movaps	  xmm5,xmm7   ; AVX2 vgather.. instuction solve
       movd	  eax,xmm5    ; this problem best
       pinsrd	  xmm7,[eax],0 ; insert double word into first position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm7,[eax],1 ; insert double word into second position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm7,[eax],2 ; insert double word into 3th position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm7,[eax],3 ; insert double word into 4th position

       movaps	  xmm5,xmm6
       movd	  eax,xmm5
       pinsrd	  xmm6,[eax],0 ; insert double word into first position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm6,[eax],1 ; insert double word into second position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm6,[eax],2 ; insert double word into 3th position
       psrldq	  xmm5,4
       movd	  eax,xmm5
       pinsrd	  xmm6,[eax],3 ; insert double word into 4th position

else

	maskmovdqu xmm1,xmm0	     ; actulize z buffer
	movd	   eax,xmm7
	mov	   eax,[eax]
	mov	   [.colI],eax
	psrldq	   xmm7,4
	movd	   eax,xmm7
	mov	   eax,[eax]
	mov	   [.colII],eax
	psrldq	   xmm7,4
	movd	   eax,xmm7
	mov	   eax,[eax]
	mov	   [.colIII],eax
	psrldq	   xmm7,4
	movd	   eax,xmm7
	mov	   eax,[eax]
	mov	   [.colIV],eax

	movd	   eax,xmm6
	mov	   eax,[eax]
	mov	   [.col2I],eax
	psrldq	   xmm6,4
	movd	   eax,xmm6
	mov	   eax,[eax]
	mov	   [.col2II],eax
	psrldq	   xmm6,4
	movd	   eax,xmm6
	mov	   eax,[eax]
	mov	   [.col2III],eax
	psrldq	   xmm6,4
	movd	   eax,xmm6
	mov	   eax,[eax]
	mov	   [.col2IV],eax

	movaps	   xmm6,[.colI]
	movaps	   xmm7,[.col2I]
end if
	pxor	   xmm5,xmm5
	movaps	   xmm4,xmm7
	movaps	   xmm3,xmm6
	punpcklbw  xmm6,xmm5
	punpcklbw  xmm7,xmm5
	punpckhbw  xmm4,xmm5
	punpckhbw  xmm3,xmm5

	pmullw	   xmm6,xmm7
	pmullw	   xmm3,xmm4
	psrlw	   xmm6,8
	psrlw	   xmm3,8
	packuswb   xmm3,xmm6
	mov	   edi,.screen
if Ext >= SSE4.1
	movups	   xmm5,[edi]
	pblendvb   xmm5,xmm3	     ; actualize z buffer
	movups	   [edi],xmm5
else
	maskmovdqu xmm3,xmm0	     ; put conditionally 4 pixels
end if
     .nd:
	add	.screen,16
	add	.czbuff,16
	movaps	xmm0,[.cbyI]
	paddd	xmm0,[.dbyI]
	movaps	[.cbyI],xmm0
    ;    movaps  xmm1,[.cbxI]
	paddd	xmm1,[.dzI]
    ;    movaps  [.cbxI],xmm1
    ;    movaps  xmm2,[.ceyI]
	paddd	xmm2,[.deyI]
    ;    movaps  [.ceyI],xmm2
	movaps	xmm3,[.cexI]
	paddd	xmm3,[.dexI]
	movaps	[.cexI],xmm3
	movaps	xmm4,[.cbxI]
	paddd	xmm4,[.dbxI]
	movaps	[.cbxI],xmm4
	dec	ecx
	jnz	.draw


   .draw_last:
	movd	.cz,xmm1
	movd	.cey,xmm2
	push	dword[.cexI]
	pop	dword .cex
	push	dword[.cbyI]
	pop	dword .cby
	push	dword[.cbxI]
	pop	dword .cbx


   .draw_last1:
	movzx	ecx,word[.rest]
	or	ecx,ecx
	jz	.bl_end

    ;    mov     edx,.cz
	mov	esi,.czbuff
	mov	edi,.screen
    .ddraw:
	mov	edx,.cz
	cmp	[esi],edx
	jle	@f
	mov	[esi],edx  ;renew z buffer
	mov	ebx,.cby
	shr	ebx,ROUND
	shl	ebx,TEX_SHIFT
	mov	eax,.cbx
	shr	eax,ROUND
	add	eax,ebx
	and	eax,TEXTURE_SIZE
	shl	eax,2
	add	eax,.bmap
	mov	eax,[eax]

	mov	ebx,.cey
	shr	ebx,ROUND
	shl	ebx,TEX_SHIFT
	mov	edx,.cex
	shr	edx,ROUND
	add	edx,ebx
	and	edx,TEXTURE_SIZE
	shl	edx,2
	add	edx,.emap
	mov	edx,[edx]
	mov	ebx,eax
	mul	dl
	mov	[edi],ah
	mov	al,bh
	mul	dh
	mov	[edi+1],ah
	shr	ebx,16
	shr	edx,16
	mov	al,bl
	mul	dl
	mov	[edi+2],ah
	mov	al,bh
	mul	dh
	mov	[edi+3],ah
     @@:
	add	esi,4
	add	edi,4
	mov	eax,.dz
	add	.cz,eax
	mov	eax,.dbx
	add	.cbx,eax
	mov	eax,.dby
	add	.cby,eax
	mov	eax,.dex
	add	.cex,eax
	mov	eax,.dey
	add	.cey,eax
	dec	 ecx
	jnz	.ddraw

  .bl_end:
	mov	esp,ebp
ret 56

